#ifndef __CGLA_H
#define __CGLA_H

#include <algorithm>
#include "ArithVec.h"
#include "Common/CommonDefs.h"

// Some of this is also in MathDefault and hence a bit redundant.
namespace CGLA
{
	/// Useful enum that represents coordiante axes.
	enum Axis {XAXIS=0,YAXIS=1,ZAXIS=2};

#ifndef WIN32
	template <class T,class V, int N>
	inline V min(const ArithVec<T,V,N>& v0, const ArithVec<T,V,N>& v1)
	{
		V v;
		for(int i=0;i<N;i++) 
			v[i] = std::min(v0[i],v1[i]);
		return v;
	}
	
	template <class T,class V, int N>
	inline V max(const ArithVec<T,V,N>& v0, const ArithVec<T,V,N>& v1)
	{
		V v;
		for(int i=0;i<N;i++) 
			v[i] = std::max(v0[i],v1[i]);
		return v;
	}
#endif

}

#endif
