#ifndef __MAT2X2F_H
#define __MAT2X2F_H

#include <math.h>
#include "Common/ExceptionStandard.h"
#include "Vec2f.h"
#include "ArithMat.h"

DERIVEEXCEPTION(Mat2x2fException, MotherException);

class Mat2x2f: public ArithMat<Vec2f, Vec2f, Mat2x2f, 2>
{
public:
  
  Mat2x2f(Vec2f _a, Vec2f _b): ArithMat<Vec2f, Vec2f, Mat2x2f, 2> (_a,_b) {}
	Mat2x2f(float _a, float _b, float _c, float _d): 
		ArithMat<Vec2f, Vec2f, Mat2x2f, 2>(Vec2f(_a,_b),Vec2f(_c,_d)) {}
  
  /// Construct the 0 matrix
  Mat2x2f() {}

};

inline float determinant(const Mat2x2f& m)
{
	return m[0][0]*m[1][1]-m[0][1]*m[1][0];
}

Mat2x2f invert(const Mat2x2f& m);

#endif
