#ifndef __MAT2X3F_H
#define __MAT2X3F_H
// Author: J. Andreas Brentzen,
// Created: Mon Sep 25 11:55:4

/**    */

#include "Vec2f.h"
#include "Vec3f.h"
#include "ArithMat.h"

class Mat2x3f: public ArithMat<Vec2f, Vec3f, Mat2x3f, 2>
{

public:
	Mat2x3f(const Vec3f& _a, const Vec3f& _b): 
		ArithMat<Vec2f, Vec3f, Mat2x3f, 2> (_a,_b) {}
	Mat2x3f() {}
	Mat2x3f(const float* sa): ArithMat<Vec2f, Vec3f, Mat2x3f, 2> (sa) {}
};

class Mat3x2f: public ArithMat<Vec3f, Vec2f, Mat3x2f, 3>
{

public:
	Mat3x2f(const Vec2f& _a, const Vec2f& _b, const Vec2f& _c): 
		ArithMat<Vec3f, Vec2f, Mat3x2f, 3> (_a,_b,_c) {}
	Mat3x2f() {}
};


#endif
