#include "Quaternion.h"

void Quaternion::make_rot(float angle, float x, float y, float z)
{
	angle = angle/180*M_PI*.5;
	qv = Vec3f(sin(angle)*x, sin(angle)*y, sin(angle)*z);
	qw = cos(angle);
};

//This function just need to call the right initialiser

Mat4x4f Quaternion::get_mat() const
{
 	float s=2/norm();
	float m[16] = {1 - s*(qv[1]*qv[1]+qv[2]*qv[2]), 
								 s*(qv[0]*qv[1]-qw*qv[2]), 
								 s*(qv[0]*qv[2]+qw*qv[1]), 
								 float(0),
	 							 s*(qv[0]*qv[1]+qw*qv[2]), 
								 1 - s*(qv[0]*qv[0]+qv[2]*qv[2]), 
								 s*(qv[1]*qv[2]-qw*qv[0]), 
								 float(0),
								 s*(qv[0]*qv[2]-qw*qv[1]), 
								 s*(qv[1]*qv[2]+qw*qv[0]), 
								 1 - s*(qv[0]*qv[0]+qv[1]*qv[1]), 
								 float(0),
								 float(0),             
								 float(0),                   
								 float(0),                
								 float(1)};
	Mat4x4f mat;
	mat.set_array(m);
	return mat;
}


Vec3f Quaternion::apply(Vec3f vec) 
{
	Quaternion quat(vec[0],vec[1],vec[2],1);
	quat = (*this)*quat*inverse();
	return Vec3f(quat.qv[0],quat.qv[1],quat.qv[2]);
}

