#include <iostream>
#include <algorithm>
#include "Vec2f.h"
#include "Mat2x2f.h"
#include "CGLA.h"

using namespace std;

bool linear_combine(const Vec2f& a, const Vec2f& b, const Vec2f& c,
										float& x, float& y)
{
	Mat2x2f mat(a[0],b[0],a[1],b[1]);

	if(is_tiny(determinant(mat))) return false;

	Mat2x2f inv_mat = invert(mat);	
	Vec2f xy = inv_mat * c;
			
	x = xy[0];
	y = xy[1];

	return true;
}

