#include <time.h>
#include "Common/CommonDefs.h"
#include "GenericRenderEngine.h"

void GenericRenderEngine::render()
{
   // init random number generator
  srandom(clock());
  double rand_max = pow(2.0,31) - 1;
  
  for (int x=0;x<canvas->get_width();x++)
    {
      for(int y=0;y<canvas->get_height(); y++)
        {
          ColorVector c;
          for (int i=0;i<samplesx;i++)
            for (int j=0;j<samplesy;j++)
              {
                float ipx, ipy;

                double randnum1 = double(random())/rand_max;
                double randnum2 = double(random())/rand_max;

                // Calculate the jittered pixel positions.
                double jpx =
                  double(x) 
                  + (double(i) + randnum1)
                  /  double(samplesx);
                
                double jpy = 
                  double(y) 
                  + (double(j) + randnum2)
                  /  double(samplesy);
                
                canvas->window_coords2image_coords(jpx,jpy,ipx,ipy);
                
                Ray r(eye->eye_position,
                      eye->get_ray_direction(ipx,ipy), SMALL);
          
                c += shader->shade_ray(r) * weight;
                canvas->draw_pixel(x,y,c);
              }
        }
      std::cout << "." << std::flush;
    }

}
