#ifndef __GENERICRENDERENGINE_H
#define __GENERICRENDERENGINE_H

#include "Eye.h"
#include "Shader.h"
#include "RenderCanvas.h"
#include "RenderEngine.h"

/// Fast becoming obsolete as AccelRenderEngine takes over its capabilites
class GenericRenderEngine: public RenderEngine
{
  ///
  Shader* shader;
  ///
  RenderCanvas* canvas;
  ///
  Eye* eye;
  
  ///
  int samplesx, samplesy;
  ///
  double weight;

public:

  ///
  GenericRenderEngine(Shader*       _shader, 
                      RenderCanvas* _canvas,
                      Eye*          _eye,
                      int _samplesx,
                      int _samplesy): 
    shader(_shader), canvas(_canvas), eye(_eye), 
    samplesx(_samplesx), samplesy(_samplesy) 
    {
      weight = 1.0 / (samplesx * samplesy);
    }

  ///
  void render();
};

#endif
