#ifndef __RENDERENGINE_H
#define __RENDERENGINE_H


/** This is a very simple abstract class containing a minimal interface 
    for the rendering classes (i.e. just one function `render').
    
    Normally a renderengine will know nothing about the scene or lights, 
    but will know about the Canvas upon which the pixels are drawn
    and the Eye that beholds the scene. */
class RenderEngine
{

public:
  /// The function that actually performs rendering. (pure virtual)
  virtual void render() = 0;
};


#endif
